Require Import Program.

(** * Notations *)

Notation "(∘)" := (fun f g=>f ∘ g) : ProgramCalculation_scope.
Notation "( f ∘)" := (fun g=>f ∘ g) (only parsing) : ProgramCalculation_scope.
Notation "(∘ g )" := (fun f=> f ∘ g) (only parsing) : ProgramCalculation_scope.

Notation "(+)" := (fun x y => x + y ) : ProgramCalculation_scope.
Notation "( x +)" := (fun y=> x + y ) (only parsing) : ProgramCalculation_scope.
Notation "(+ x )" := (fun y=> y + x ) (only parsing) : ProgramCalculation_scope.

Notation "( * )" := (fun x y=>x * y)  : ProgramCalculation_scope.
Notation "( x *)" := (fun y=>x * y) (only parsing) : ProgramCalculation_scope.
Notation "(* x )" := (fun y=>y * x) (only parsing) : ProgramCalculation_scope.

Notation "(-)" := (fun x y=>x - y) : ProgramCalculation_scope.
Notation "( x -)" := (fun y=>x - y) (only parsing) : ProgramCalculation_scope.
Notation "(- x )" := (fun y=>y - x) (only parsing) : ProgramCalculation_scope.

Open Scope ProgramCalculation_scope.
